﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.Enum
@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}

<script src="~/Script/Master/Layout.js"></script>
<section>
    <input data-val="true" data-val-number="The field ServiceId must be a number." data-val-required="The ServiceId field is required." id="ServiceId" name="ServiceId" type="hidden" value="0">
    @if (ViewBag.message != null)
    {
        <script>toastr.success('@ViewBag.message')</script>
    }
    else if (ViewBag.error != null)
    {
        <script>toastr.error('@ViewBag.error')</script>
    }
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Enum List</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form asp-area="Master" asp-controller="Enum" asp-action="SaveEnum" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'Master/Enum/Index');"
                              data-ajax-failure="Errmsg(data);">
                            <input type="hidden" name="Id" id="Id" value="@Model.Id" />
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Enum Type</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" asp-for="EnumTypeId" onchange="fnHighestValueForEnum(this)" required>
                                            <option value="0">Select Enum Type</option>
                                            @foreach (var enumType in Model.EnumTypes)
                                            {
                                                <option value="@enumType.Id">@enumType.Name</option>
                                            }
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Enum Value</label>
                                    <div class="select_box m_bottom">
                                        <input type="number" class="form-control m_no" name="Value" id="Value" value="@Model.Value" readonly>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Enum Name</label>
                                    <div class="select_box m_bottom">
                                        <input type="text" class="form-control m_no" asp-for="Name" placeholder="Enter Enum Name">
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Enum Title</label>
                                    <div class="select_box m_bottom">
                                        <input type="text" class="form-control m_no" asp-for="Title" placeholder="Enter Enum Title">
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <div class="submitbtn">
                                        <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                    </div>
                                    <div class="submitbtn">
                                        <input type="submit" id="btnsubmit" name="Submit" value="Submit" />
                                        <input type="reset" id="reset" value="reset" hidden />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="addbtn">
                            <div class="add_litigation">
                                <span>+</span>
                                <input type="button" id="btnHideShow" onclick="showForm()" value="Add Enum">
                            </div>
                        </div><!--edn of addbtn-->
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width: 70px;">SN</th>
                                                <th>Enum Type Name</th>
                                                <th>Enum Value</th>
                                                <th>Enum Name</th>
                                                <th>Enum Title</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.Enums)
                                            {
                                                <tr>
                                                    <td>@(++sn)</td>
                                                    <td>@Model.EnumTypes.Where(x => x.Id == item.EnumTypeId).Select(x => x.Name).FirstOrDefault()</td>
                                                    <td>@item.Value</td>
                                                    <td>@item.Name</td>
                                                    <td>@item.Title</td>
                                                    <td>
                                                        <a href="#" onclick="fnUpdate('@item.Id', '@item.EnumTypeId', '@item.Value', '@item.Name', '@item.Title')" class="edit_btn"></a>
                                                        @if (item.IsActive)
                                                        {
                                                            <a class="btn btn-info btn-xs pull-left" onclick="fn_Activeincative('@item.Id', '@(item.IsActive?"deactivate":"activate")')"><i class="fa fa-check" aria-hidden="true"></i></a>
                                                        }
                                                        else
                                                        {
                                                            <a class="btn btn-danger btn-xs pull-left" onclick="fn_Activeincative('@item.Id', '@(item.IsActive?"deactivate":"activate")')"><i class="fa fa-times" aria-hidden="true"></i></a>
                                                        }
                                                        <a class="delete_btn" onclick="Confirmation('@item.Id')"></a>
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
@*@await Html.PartialAsync("_ValidationScriptsPartial")*@
<script type="text/javascript">
    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
        //$('#btnHideShow').val('Cancel').removeAttr('onclick').attr('onclick', 'hideForm()');
        $('#form').removeAttr('action').attr('action', '/Master/Enum/SaveEnum');
    }
    function hideForm() {
        $('#reset').click();
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
        //$('#btnHideShow').val('Add Enum Type').removeAttr('onclick').attr('onclick', 'showForm()');
        $('#form').removeAttr('action').attr('action', '/Master/Enum/SaveEnum');
    }
    function fnUpdate(Id, EnumTypeId, Value, Name, Title) {
        showForm()
        $('#Id').val(Id);
        $('#EnumTypeId').val(EnumTypeId);
        $('#Value').val(Value);
        $('#Name').val(Name);
        $('#Title').val(Title);
        $('#form').removeAttr('action').attr('action', '/Master/Enum/UpdateEnum');
        //toastr.success("Update successfully!!");
    }
    function fnBlockDelete(Id, Action, Type) {
            $.getJSON('/Master/Enum/BlockDeleteEnum', { Id: Id, Type: Type }, function (data) {
                if (data > 0) {
                    if (Type != 0) {
                        toastr.success(Action + " " + 'successfully!!');
                    } else {
                        toastr.success(Action + " " + 'successfully!!');
                    }
                    setTimeout(function () { window.location.reload(); }, 2000);
                }
            });
    }
    function fnHighestValueForEnum(select) {
        var EnumTypeId = parseInt($(select).val());
        var id = parseInt($('#Id').val());
        if (id == 0) {
            $.get('/Master/Enum/GetHighestValueForEnum', { id: EnumTypeId }, function (data) {
                $('#Value').val(data + 1);
            });
        }
    }
    $("input[type=submit]").click(function (event) {
        if ($("select[name=EnumTypeId]").val() == 0) {
            event.preventDefault();
            toastr.error("Select enum type.");
        } else if ($("input[name=Name]").val() == "") {
            event.preventDefault();
            toastr.error("Enum name is required.");
        } else if ($("input[name=Title]").val() == "") {
            event.preventDefault();
            toastr.error("Enum title is required.");
        }
    });
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this enum',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Enum/BlockDeleteEnum",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/Master/Enum/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            } else if (result.isDenied) {
                Swal.fire('Changes are not saved', '', 'info')
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this enum',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Enum/BlockDeleteEnum",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/Master/Enum/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>

